/***********************
        misc.js
    Misc functions.
***********************/

var gConsole;		//Accessible through the JS command.

function RandomInt(start, end)
{
	return Math.round(Math.random() * (end-start)) + start;
}



/********************
  STANDARD PROGRAMS
    AND COMMANDS
********************/
var programs = [];



/********************
        HELP
 Simple help program.
********************/
programs["help"] = new Program("help");
programs["help"].run = function()
{
	console.println("== LIST OF COMMANDS ==");
	console.println("dir       cls       " + appname.toLowerCase());
	console.println("js        exit      about");
	console.println("echo      run");
}



/********************
				 CD
	Navigate through
		directories.
********************/
programs["cd"] = new Program("cd");
programs["cd"].run = function(paramstring)
{
	if (this.params.length == 0)
		console.println("Usage:"),
		console.println("cd [directory]"),
		console.println("NOTE: in this version you cannot enter more than one directory.");
	
	//Parameter was given
	else if (this.params[0] == "/" || this.params[0] == "\\")
		console.directory = "./";
	
	else
		console.directory = this.params[0] + "/";
	
	//END PROGRAM: remove parameters.
	this.params = [];
}


/********************
				DIR
 View a directory's
		 contents.
********************/
programs["dir"] = new Program("dir");
programs["dir"].run = function()
{
	//Check if there are parameters.
	if (this.params.length > 0)
	{
		//Check if parameter is /?
		if (this.params[0] == "/?")
		{
			console.println("DIR");
			console.println("Shows the list of files and directories of the current directory.");
			console.println();
			console.println("Commandline parameters:");
			console.println("/? Shows this screen");
			console.println("<directory name> shows contents of directory");
		}
		
		else if (this.params[0] == "programs" || this.params[0] == "games")
		{
			//List programs.
			var list = GetGameList();
			{	for (var i = 0, length = list.length; i < length; i++)
					console.println(list[i].directory);
			}
		}
		
		//Else, the parameter is probably a subdirectory.
		else
		{
			//Does directory exist (or does it have files)?
			var filelist = GetFileList(this.params[0]);
			var dirlist = GetDirectoryList();
			var files = dirlist;
			if (files.length == 0)
				console.println("Directory empty or inexistant");
			
			else
			{	for (var i = 0; i < files.length; i++)
					console.println(files[i]);
			}
		}
	}
	
	//Else, no parameters were given, so print this directory's contents.
	else
	{
		var files = GetFileList(console.directory);
		
		if (files.length == 0)
			console.println("This directory contains no files, or it does not exist.");
		
		else
		{	for (var i = 0; i < files.length; i++)
				console.println(files[i]);
		}
	}
	
	//END PROGRAM: remove parameters.
	this.params = [];
}




programs["echo"] = new Program();
programs["echo"].run = function(params)
{
	console.println(params);
	this.params = [];
}

programs["echo."] = new Program();
programs["echo."].run = function(params)
{
	console.line++;
	this.params = [];
}



programs["run"] = new Program();
programs["run"].run = function(params)
{
	//Check if the program exists first.
	
	if (this.params.length > 0)
		ExecuteGame(this.params[0]);
	
	else
		console.println("Runs a Sphere game."),
		console.println("Usage: run [gamefolder]");
	
	//END PROGRAM: remove parameters.
	this.params = [];
}

programs["start"] = programs["run"];



//Commands with parameters 'n shit.
function AdvancedCommands(console, input)
{
	var result = true;
	
	/********************
	         JS
	 Evaluate Javascript.
	********************/
	if (input.substr(0, 2) == "js")
	{
		if (input.substr(3, input.length-3) != "")
		{
			gConsole = console;
			console.command = "";
			
			try
			{
				eval(input.substr(3, input.length-3));
				console.println("Done.");
			}
			catch (e)
			{
				console.println("Could not evaluate code!");
				console.println(e);
			}
		}
		
		else
			console.line++,
			console.println("Usage:"),
			console.println("js [code to evaluate]");
	}
	
	else
		result = false;
	
	return result;
}

